/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "cytypes.h"
#include "cyfitter.h"
#include "cyfitter_cfg.h"





#define DC_LOW		DC_Write(0)
#define DC_HIGH		DC_Write(1)
#define CS_LOW		CS_Write(0)
#define CS_HIGH		CS_Write(1)

#define FONT_SPACE 6

//Basic Colors
#define RED		0xf800
#define GREEN	0x07e0
#define BLUE	0x001f
#define BLACK	0x0000
#define YELLOW	0xffe0
#define WHITE	0xffff

//Other Colors
#define CYAN		0x07ff	
#define BRIGHT_RED	0xf810	
#define GRAY1		0x8410  
#define GRAY2		0x4208  

//TFT resolution 240*320
#define MIN_X	0
#define MIN_Y	0
#define MAX_X	239
#define MAX_Y	319

//Box line boundaries
#define X_BOUNDARY_1 80
#define X_BOUNDARY_2 160
#define Y_BOUNDARY_1 106
#define Y_BOUNDARY_2 212

#define O_RADIUS 20

// Centre points for all boxes
#define BOX_1_CENTRE_X	200
#define BOX_1_CENTRE_Y	53
#define BOX_2_CENTRE_X	200
#define BOX_2_CENTRE_Y	160
#define BOX_3_CENTRE_X	200
#define BOX_3_CENTRE_Y	266
#define BOX_4_CENTRE_X	120
#define BOX_4_CENTRE_Y	53
#define BOX_5_CENTRE_X	120
#define BOX_5_CENTRE_Y	160
#define BOX_6_CENTRE_X	120
#define BOX_6_CENTRE_Y	266
#define BOX_7_CENTRE_X	40
#define BOX_7_CENTRE_Y	53
#define BOX_8_CENTRE_X	40
#define BOX_8_CENTRE_Y	160
#define BOX_9_CENTRE_X	40
#define BOX_9_CENTRE_Y	266

// Boundaries for printing the winner
#define X_BOUNDARY_LOW 85
#define X_BOUNDARY_HIGH 135
#define X_BOUNDARY_CENTRE 110

#define Y_1_BOUNDARY_LOW 241
#define Y_1_BOUNDARY_HIGH 291
#define Y_1_BOUNDARY_CENTRE 266
#define Y_1_O_RADIUS 30

#define Y_2_BOUNDARY_LOW 140
#define Y_2_BOUNDARY_HIGH 200
#define Y_2_BOUNDARY_CENTRE 170

#define Y_3_BOUNDARY_LOW 95
#define Y_3_BOUNDARY_HIGH 125
#define Y_3_BOUNDARY_CENTRE 110

#define Y_4_BOUNDARY_LOW 10
#define Y_4_BOUNDARY_HIGH 60
#define Y_4_BOUNDARY_CENTRE 35

// Boundaries for printing TIE
#define Y_HIGH_BOUNDARY_E 160
#define Y_LOW_BOUNDARY_E 130
#define Y_LINE_I 180
#define Y_LEFT_T 226
#define Y_RIGHT_T 201

/* Number of boxes*/
#define NO_OF_BOXES 9

// ADC thresholds for the boxes
#define BOX_1_X_THRES_MIN	0x500
#define BOX_1_X_THRES_MAX	0x5FF
#define BOX_1_Y_THRES_MIN	0x120
#define BOX_1_Y_THRES_MAX	0x180
#define BOX_2_X_THRES_MIN	0x5A0
#define BOX_2_X_THRES_MAX	0x600
#define BOX_2_Y_THRES_MIN	0x300
#define BOX_2_Y_THRES_MAX	0x400
#define BOX_3_X_THRES_MIN	0x5C0
#define BOX_3_X_THRES_MAX	0x620
#define BOX_3_Y_THRES_MIN	0x500
#define BOX_3_Y_THRES_MAX	0x600
#define BOX_4_X_THRES_MIN	0x400
#define BOX_4_X_THRES_MAX	0x4F0
#define BOX_4_Y_THRES_MIN	0x130
#define BOX_4_Y_THRES_MAX	0x210
#define BOX_5_X_THRES_MIN	0x3A0
#define BOX_5_X_THRES_MAX	0x400
#define BOX_5_Y_THRES_MIN	0x300
#define BOX_5_Y_THRES_MAX	0x400
#define BOX_6_X_THRES_MIN	0x380
#define BOX_6_X_THRES_MAX	0x440
#define BOX_6_Y_THRES_MIN	0x5C0
#define BOX_6_Y_THRES_MAX	0x620
#define BOX_7_X_THRES_MIN	0x1B0
#define BOX_7_X_THRES_MAX	0x240
#define BOX_7_Y_THRES_MIN	0x150
#define BOX_7_Y_THRES_MAX	0x220
#define BOX_8_X_THRES_MIN	0x160
#define BOX_8_X_THRES_MAX	0x220
#define BOX_8_Y_THRES_MIN	0x380
#define BOX_8_Y_THRES_MAX	0x410
#define BOX_9_X_THRES_MIN	0x180
#define BOX_9_X_THRES_MAX	0x1F0
#define BOX_9_Y_THRES_MIN	0x5C0
#define BOX_9_Y_THRES_MAX	0x610


void Touch_Location(void);
void Fill_Circle(uint16 Pos_X, uint16 Pos_Y, uint16 Radius, uint16 Color);
void Draw_Circle(uint16 Pos_X, uint16 Pos_Y, uint16 Radius, uint16 Color);
void Draw_Line(uint16 X0, uint16 Y0, uint16 X1, uint16 Y1, uint16 Color);
void Draw_V_Line(uint16 Pos_X, uint16 Pos_Y, uint16 Length, uint16 Color);
void Draw_H_Line(uint16 Pos_X, uint16 Pos_Y, uint16 Length, uint16 Color);
void Set_Col(uint16 Start_Col, uint16 End_Col);
void Set_Page(uint16 Start_Page, uint16 End_Page);
void Goto_XY(uint16 Pos_X, uint16 Pos_Y);
void Set_Pixel(uint16 Pos_X, uint16 Pos_Y, uint16 Color);
void TFT_Start(void);
void Fill_Color(uint16 XL, uint16 XR, uint16 YU, uint16 YD, uint16 Color);
void Set_Page(uint16 Start_Page, uint16 End_Page);
void Fill_Screen(void);
void Send_Data16(uint16 dat);
void Send_Data(uint8 dat);
void Send_Cmd(uint8 cmd);
void SPI_Transfer(uint8 data_tx);
void TouchDetect(void);
void DisplayPattern();
void Check_Winner();
//[] END OF FILE
